#ifndef _ENCOMPASS_WINDOW_H_
#define _ENCOMPASS_WINDOW_H_
#include <gtkhtml/htmlobject.h>

struct _BrowserWindow {
  GtkWidget * window ;
  GtkTooltips * tips;
  GtkWidget * status;
  GtkWidget * html;
  GtkWidget * animator;
  GtkWidget * entry;

  GList * go_list;
  GList * entry_list;
  gint go_position;
  GSList * group;

  GtkHTMLStream * handle;
  GList * sessions;
  EncompassURI * base;
  EncompassURI * referer;
  guint good_mime;

  GtkWidget * urlbar;
  GtkWidget * navbar;

  GtkWidget * book_menu;
  GtkWidget * back_menu_item;
  GtkWidget * fore_menu_item;
  GtkWidget * go_menu_item;
  GtkWidget * back_tool_item;
  GtkWidget * fore_tool_item;
  GtkWidget * popup_item;
  GtkWidget * back_pop_item;
  GtkWidget * fore_pop_item;
  GtkWidget * stop_menu_item;
  GtkWidget * stop_tool_item;

  GMutex * data_mtx;
  GMutex * gtk_mtx;
  GMutex * counter_mtx;
  GMutex * event_loop_mtx;

  HTMLObject * object;

  EncompassPrefs * prefs;
  ECookies * cookies;
};

void encompass_window_close (GtkWidget * widget, BrowserWindow * window);
void encompass_toggle_statusbar (GtkWidget * widget, BrowserWindow * window);
void encompass_create_window (GtkWidget * widget, gchar * url);

#endif
